Sketch Class

class NXOpen.Sketch

Bases: NXOpen.DisplayableObject, NXOpen.IProfile

Represents a sketch

Use the NXOpen.SketchCollection class to create a sketch.

New in version NX3.0.0.

Properties

Property Description
AttachPlane Returns the plane that the sketch is attached to
Color Returns or sets the color of the object.
CreateInferConstraintsSetting Returns or sets the toggle that controls the creation of infer constraints in sketch
DOFDisplay Returns or sets a flag indicating whether the degree of freedom arrows are currently being displayed
Feature Returns the feature associated with this sketch
IsActive Returns true if the sketch is active
IsBlanked Returns the blank status of this object.
IsDraftingSketch Returns true if drafting sketch
IsInternal Returns true if the sketch is internal.
IsOccurrence Returns whether this object is an occurrence or not.
JournalIdentifier Returns the identifier that would be recorded in a journal for this object.
Layer Returns or sets the layer that the object is in.
LineFont Returns or sets the line font of the object.
LineWidth Returns or sets the line width of the object.
Name Returns the custom name of the object.
NameLocation Returns the location of the object’s name.
Orientation Returns the orientation matrix of the local coordinate system of the sketch
Origin Returns the location of the origin of the local coordinate system for the sketch
OwningComponent Returns the owning component, if this object is an occurrence.
OwningPart Returns the owning part of this object
Prototype Returns the prototype of this object if it is an occurrence.
Tag Returns the Tag for this object.
UpdateScope Returns or sets the current update scope.
View Returns the view corresponding to sketch
VisibilityOfConstraints Returns or sets the visibility of the constraints in the sketch
Preferences
Contains preferences for the sketch

Methods

Method Description
Activate Activates the sketch
AddGeometry Adds a curve or point to the sketch
AutoConstrain Creates Automatic Constraints on input set of geometries.
Blank Blanks the object.
BreakAssociativity Breaks associativity of recipe geometry (projected or intersection curves and points) in the sketch, making the curves regular sketch geometry.
ConvertToNx10Spline Convert the legacy splines to new NX10 splines.
CopyObjects Creates copies of input objects and constraints between these objects.
CopyObjectsWithDimensionOutput Creates copies of input objects and constraints between these objects.
CopyObjectsWithTracking Creates copies of input objects and constraints between these objects.
CreateAttributeIterator Create an attribute iterator @return A new attribute iterator object
CreateCoincidentConstraint Creates a coincident constraint @return The coincident constraint
CreateCollinearConstraint Creates a collinear constraint.
CreateConcentricConstraint Creates a concentric constraint.
CreateConstantAngleConstraint Creates a constant angle constraint @return The constant angle constraint
CreateConstantLengthConstraint Creates a constant length constraint @return The constant length constraint
CreateDiameterDimension Creates a diameter dimension constraint @return The diametral dimension constraint
CreateDimension Creates a dimension between two geometric objects.
CreateEqualLengthConstraint Creates an equal length constraint.
CreateEqualRadiusConstraint Creates an equal radius constraint.
CreateFixedConstraint Creates a fixed constraint @return The fixed constraint
CreateFullyFixedConstraints Creates enough fixed constraints on the curve and all of its vertices such that the geometry is fully fixed without any redundant fixed constraints.
CreateHorizontalConstraint Creates a horizontal constraint @return The horizontal constraint
CreateMidpointConstraint Creates a midpoint constraint.
CreateNonUniformScaledConstraint Creates a non-uniform scale constraint @return The non-uniform scale constraint
CreateNormalConstraint Creates a normal constraint.
CreateParallelConstraint Creates a parallel constraint.
CreatePerimeterDimension Creates a perimeter dimension constraint @return The perimeter dimensional constraint
CreatePerpendicularConstraint Creates a perpendicular constraint.
CreatePointOnCurveConstraint Creates a point on curve constraint.
CreatePointOnStringConstraint Creates a point on string constraint.
CreateRadialDimension Creates a radial dimension constraint @return The radial dimension constraint
CreateSlopeConstraint Creates a slope constraint.
CreateTangentConstraint Creates a tangent constraint.
CreateUniformScaledConstraint Creates a uniform scale constraint @return The uniform scale constraint
CreateVerticalConstraint Creates a vertical constraint @return The vertical constraint
Deactivate Deactivates the sketch
DeleteAllAttributesByType Deletes all attributes of a specific type.
DeleteAttributeByTypeAndTitle Deletes an attribute by type and title.
DeleteConstraintsOnGeometries Deletes all geometric constraints associated with the object and all of its vertices.
DeleteObjects Deletes objects from the sketch @return List of errors encountered during the delete
DeleteUserAttribute Deletes the first attribute encountered with the given Type, Title.
DeleteUserAttributes Deletes the attributes on the object, if any, that satisfy the given iterator
EditSplineDefiningPoints Changes the locations of the defining points of a spline.
EditSplinePoles Changes the locations of the control poles of a spline.
Fillet Fillets curves and creates appropriate constraints.
FindObject Finds the NXOpen.NXObject with the given identifier as recorded in a journal.
FlipNormal Flips the outward normal vector of the sketch
FlipReferenceDirection Flips the reference direction of the sketch
GetAllConstraintsOfType Gets all constraints in the sketch of a particular type @return All the constraints in the sketch of the specified type
GetAllExpressions Returns all the expressions in the sketch @return All the expressions in the sketch
GetAllGeometry Returns all the curves and points in the sketch @return All the curves and points in the sketch
GetAttributeTitlesByType Gets all the attribute titles of a specific type.
GetBooleanUserAttribute Gets a boolean attribute by Title and array Index.
GetComputationalTimeUserAttribute Gets a time attribute by Title and array Index.
GetConstraintsForGeometry Gets all the constraints associated with a particular geometric item @return All the constraints associated with the geometry that is input
GetIntegerAttribute Gets an integer attribute by title.
GetIntegerUserAttribute Gets an integer attribute by Title and array Index.
GetNextUserAttribute Gets the next attribute encountered on the object, if any, that satisfies the given iterator.
GetRealAttribute Gets a real attribute by title.
GetRealUserAttribute Gets a real attribute by Title and array Index.
GetReferenceAttribute Gets the reference string (not the calculated value) of a string attribute that uses a reference string.
GetReferenceDirection Gets the reference direction of the sketch @return
GetStatus Gets the status of the sketch and the number of degrees of freedom that remain in the sketch.
GetStringAttribute Gets a string attribute value by title.
GetStringUserAttribute Gets a string attribute by Title and array Index.
GetTimeAttribute Gets a time attribute by title.
GetTimeUserAttribute Gets a time attribute by Title and array Index.
GetUserAttribute Gets the first attribute encountered on the object, if any, with a given Title, Type and array Index.
GetUserAttributeAsString Gets the first attribute encountered on the object, if any, with a given title, type and array index.
GetUserAttributeCount Gets the count of set attributes on the object, if any, that satisfy the given iterator.
GetUserAttributeLock Determine the lock of the given attribute.
GetUserAttributeSize Gets the size of the first attribute encountered on the object, if any, with a given Title and Type.
GetUserAttributeSourceObjects Returns an array of objects from which this object presents attributes.
GetUserAttributes Gets all the attributes that have been set on the given object, if any, that satisfy the given iterator.
GetUserAttributesAsStrings Gets all the attributes that have been set on the given object.
HasUserAttribute Determines if an attribute exists on the object, that satisfies the given iterator @return
HideDimensions Blanks dimensions in the active sketch associated with the input sketch geometry.
Highlight Highlights the object.
LocalUpdate Update the sketch and not the sketch children.
MakeDatumsExternal Makes the internal sketch placement face and directional reference datums external.
MakeDatumsExternal2 Makes the internal sketch placement face and directional reference datums external.
MakeDatumsInternal Makes the sketch placement face and directional reference internal to the sketch if they are both datums referenced only by the sketch.
ManageConstraintsAfterEdit Deletes or adjusts constraints of the input geometry that are incompatible after geometry edit.
MirrorObjects Creates a reflection of the input geometry.
Print Prints a representation of this object to the system log file.
Reattach Reattaches a sketch.
RedisplayObject Redisplays the object in all views.
RemoveRedundantVertices Remove redundant vertices of the given sketch geometry
RemoveViewDependency Remove dependency on all views from an object.
RunAutoDimension Run auto dimensioning.
Scale Scale the sketch entities by the given scale factor.
SetAttribute Creates or modifies an integer attribute.
SetBooleanUserAttribute Creates or modifies a boolean attribute with the option to update or not.
SetName Sets the custom name of the object.
SetNameLocation Sets the location of the object’s name.
SetReferenceAttribute Creates or modifies a string attribute which uses a reference string.
SetReferenceDirection Sets the reference direction of the sketch.
SetTimeAttribute Creates or modifies a time attribute.
SetTimeUserAttribute Creates or modifies a time attribute with the option to update or not.
SetUserAttribute Creates or modifies an attribute with the option to update or not.
SetUserAttributeLock Lock or unlock the given attribute.
ShowDimensions Unblanks dimensions in the active sketch associated with the input sketch geometry
Unblank Unblanks the object.
Unhighlight Unhighlights the object.
Update Updates the sketch
UpdateConstraintDisplay Updates the constraint display without updating the sketch
UpdateDimensionDisplay Updates the dimension display without updating the sketch
UpdateGeometryDisplay Updates the geometry display without updating the sketch

Enumerations

SketchAddEllipseOption Enumeration Used by NXOpen.Sketch.AddGeometry() to determine whether to treat an ellipse as an ellipse or generic conic when adding the curve to a sketch.
SketchAlternateSolutionOption Enumeration Indicates whether the alternate solution should be used instead of the regular solution.
SketchAssocType Enumeration Used in NXOpen.SketchDimensionGeometry_Struct to indicate what type of geometry to use
SketchAutoDimensioningRule Enumeration Type of Auto Dimensioning rules.
SketchConstraintClass Enumeration Represents the class of the constraint.
SketchConstraintGeometryHelpType Enumeration Used in ConstraintHelp to indicate what type of help it is
SketchConstraintPointType Enumeration Used in ConstraintGeometry to indicate what type of point, if any, the geometry is
SketchConstraintType Enumeration Represents the type of constraint
SketchConstraintVisibility Enumeration Indicates the visibility of the constraints The APIs that use this enum are deprecated in NX85 The NXOpen.SketchConstraintVisibility.Some option will behave the same as the NXOpen.SketchConstraintVisibility.All option.
SketchCreateDimensionOption Enumeration Used in fillet to indicate whether a radius dimension should be created by the fillet
SketchCreateInferConstraintSetting Enumeration Indicates if the infer constraints will be created or not
SketchDeleteThirdCurveOption Enumeration Indicates whether the 3rd curve should be deleted when doing a 3 curve fillet
SketchDimensionOption Enumeration Used by NXOpen.Sketch.CreateDimension(), NXOpen.Sketch.CreateRadialDimension() NXOpen.Sketch.CreateDiameterDimension() and NXOpen.Sketch.CreatePerimeterDimension() to determine whether to create driving or reference dimension
SketchInferConstraintsOption Enumeration Used when adding a point or curve to a sketch.
SketchPlaneOption Enumeration Specifies the plane type used for a Sketch
SketchStatus Enumeration Represents the status of the sketch
SketchTrimInputOption Enumeration Indicates whether the input curves should be trimmed when doing a fillet
SketchUpdateLevel Enumeration Used to indicate how much the updating should occur
SketchViewReorient Enumeration Used to indicate whether to reorient the view when the sketch is activated

Structs

SketchConstraintGeometry_Struct Struct Used by the create geometric constraint methods to indicate what geometry the constraint should be applied to.
SketchConstraintGeometryHelp_Struct Struct Used by several constraint creation methods that need a help point or parameter to indicate how to create the constraint.
SketchCopyObjectData_Struct Struct This structure represents a map between the original object to be copied and the corresponding copied object.
SketchDimensionGeometry_Struct Struct Used in the dimension creation methods to indicate what geometry to create the dimension on.

Property Detail

AttachPlane

Sketch.AttachPlane

Returns the plane that the sketch is attached to

-------------------------------------

Getter Method

Signature AttachPlane()

Returns:
Return type:NXOpen.ISurface

New in version NX3.0.0.

License requirements: None.

CreateInferConstraintsSetting

Sketch.CreateInferConstraintsSetting

Returns or sets the toggle that controls the creation of infer constraints in sketch

-------------------------------------

Getter Method

Signature CreateInferConstraintsSetting()

Returns:
Return type:NXOpen.SketchCreateInferConstraintSetting

New in version NX4.0.0.

License requirements: None.

-------------------------------------

Setter Method

Signature CreateInferConstraintsSetting(createInferCon)

Parameters:createInferCon (NXOpen.SketchCreateInferConstraintSetting) –

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

DOFDisplay

Sketch.DOFDisplay

Returns or sets a flag indicating whether the degree of freedom arrows are currently being displayed

-------------------------------------

Getter Method

Signature DOFDisplay()

Returns:
Return type:bool

New in version NX3.0.0.

License requirements: None.

-------------------------------------

Setter Method

Signature DOFDisplay(displayDof)

Parameters:displayDof (bool) –

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

Feature

Sketch.Feature

Returns the feature associated with this sketch

-------------------------------------

Getter Method

Signature Feature()

Returns:Associated feature
Return type:NXOpen.Features.Feature

New in version NX3.0.0.

License requirements: None.

IsActive

Sketch.IsActive

Returns true if the sketch is active

-------------------------------------

Getter Method

Signature IsActive()

Returns:
Return type:bool

New in version NX3.0.0.

License requirements: None.

IsDraftingSketch

Sketch.IsDraftingSketch

Returns true if drafting sketch

-------------------------------------

Getter Method

Signature IsDraftingSketch()

Returns:
Return type:bool

New in version NX6.0.0.

License requirements: None.

IsInternal

Sketch.IsInternal

Returns true if the sketch is internal.

-------------------------------------

Getter Method

Signature IsInternal()

Returns:
Return type:bool

New in version NX6.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR geometric_tol (“GDT”)

IsOccurrence

Sketch.IsOccurrence

Returns whether this object is an occurrence or not.

-------------------------------------

Getter Method

Signature IsOccurrence()

Returns:This object is an occurrence
Return type:bool

New in version NX3.0.0.

License requirements: None.

JournalIdentifier

Sketch.JournalIdentifier

Returns the identifier that would be recorded in a journal for this object.

This may not be the same across different releases of the software.

-------------------------------------

Getter Method

Signature JournalIdentifier()

Returns:
Return type:str

New in version NX3.0.0.

License requirements: None.

Name

Sketch.Name

Returns the custom name of the object.

-------------------------------------

Getter Method

Signature Name()

Returns:
Return type:str

New in version NX3.0.0.

License requirements: None.

Orientation

Sketch.Orientation

Returns the orientation matrix of the local coordinate system of the sketch

-------------------------------------

Getter Method

Signature Orientation()

Returns:
Return type:NXOpen.NXMatrix

New in version NX3.0.0.

License requirements: None.

Origin

Sketch.Origin

Returns the location of the origin of the local coordinate system for the sketch

-------------------------------------

Getter Method

Signature Origin()

Returns:
Return type:NXOpen.Point3d

New in version NX3.0.0.

License requirements: None.

OwningComponent

Sketch.OwningComponent

Returns the owning component, if this object is an occurrence.

-------------------------------------

Getter Method

Signature OwningComponent()

Returns:
Return type:NXOpen.Assemblies.Component

New in version NX3.0.0.

License requirements: None.

OwningPart

Sketch.OwningPart

Returns the owning part of this object

-------------------------------------

Getter Method

Signature OwningPart()

Returns:The owning part of this object or null if it does not have an owner
Return type:NXOpen.BasePart

New in version NX3.0.0.

License requirements: None.

Prototype

Sketch.Prototype

Returns the prototype of this object if it is an occurrence.

-------------------------------------

Getter Method

Signature Prototype()

Returns:The prototype of this object or null if this object is not an occurrence
Return type:NXOpen.INXObject

New in version NX3.0.0.

License requirements: None.

UpdateScope

Sketch.UpdateScope

Returns or sets the current update scope.

Used in Direct Sketch to control update

-------------------------------------

Getter Method

Signature UpdateScope()

Returns:
Return type:NXOpen.SketchUpdateLevel

New in version NX8.0.0.

License requirements: None.

-------------------------------------

Setter Method

Signature UpdateScope(updateScope)

Parameters:updateScope (NXOpen.SketchUpdateLevel) –

New in version NX8.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

View

Sketch.View

Returns the view corresponding to sketch

-------------------------------------

Getter Method

Signature View()

Returns:View corresponding to sketch
Return type:NXOpen.View

New in version NX6.0.0.

License requirements: None.

VisibilityOfConstraints

Sketch.VisibilityOfConstraints

Returns or sets the visibility of the constraints in the sketch

-------------------------------------

Getter Method

Signature VisibilityOfConstraints()

Returns:
Return type:NXOpen.SketchConstraintVisibility

New in version NX3.0.0.

Deprecated since version NX8.5.0: Use NXOpen.Preferences.SessionSketch.DisplayConstraintSymbols() instead.

License requirements: None.

-------------------------------------

Setter Method

Signature VisibilityOfConstraints(visibility)

Parameters:visibility (NXOpen.SketchConstraintVisibility) –

New in version NX3.0.0.

Deprecated since version NX8.5.0: Use NXOpen.Preferences.SessionSketch.DisplayConstraintSymbols() instead.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

Preferences

Sketch.Preferences

Contains preferences for the sketch

Signature Preferences()

New in version NX3.0.0.

Returns:
Return type:NXOpen.Preferences.SketchPreferences

Method Detail

Activate

Sketch.Activate

Activates the sketch

Signature Activate(orientView)

Parameters:orientView (NXOpen.SketchViewReorient) – Indicates whether to orient the view to the sketch during activation

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

AddGeometry

Sketch.AddGeometry

Overloaded method AddGeometry

  • AddGeometry(crv, inferCoincidentConstraints)
  • AddGeometry(crv)
  • AddGeometry(crv, inferCoincidentConstraints, ellipseOption)
  • AddGeometry(inferCoincidentConstraints, ellipseOption, curvesOrPoints)

-------------------------------------

Adds a curve or point to the sketch

Signature AddGeometry(crv, inferCoincidentConstraints)

Parameters:
  • crv (NXOpen.DisplayableObject) – Must be a curve or point
  • inferCoincidentConstraints (NXOpen.SketchInferConstraintsOption) – Whether to automatically create coincident constraints when adding the geometry. If this flag is true and there exists another curve or point in the sketch that has a vertex that is at the same location (within system tolerance) as one of the vertices for crv, a coincident constraint will be created

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Adds a curve or point to the sketch. Infers coincident constraints with other geometry in the sketch

Signature AddGeometry(crv)

Parameters:crv (NXOpen.DisplayableObject) – Must be a curve or point

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Adds a curve or point to a sketch.

Signature AddGeometry(crv, inferCoincidentConstraints, ellipseOption)

Parameters:
  • crv (NXOpen.Curve) – Must be a curve or point
  • inferCoincidentConstraints (NXOpen.SketchInferConstraintsOption) – Whether to automatically create coincident constraints when adding the geometry. If this flag is true and there exists another curve or point in the sketch that has a vertex that is at the same location (within system tolerance) as one of the vertices for crv, a coincident constraint will be created
  • ellipseOption (NXOpen.SketchAddEllipseOption) – If you are adding an ellipse to the sketch, this parameter indicates whether the ellipse should be treated as an ellipse or general conic. If you are not adding an ellipse, the option is ignored. See the documentation for NXOpen.SketchAddEllipseOption for more details. The default value is NXOpen.SketchAddEllipseOption.TreatAsEllipse. In order to treat an ellipse as a conic, its end angle minus its start angle must be less than 180 degrees.

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Adds an array of curves or points to a sketch.

Signature AddGeometry(inferCoincidentConstraints, ellipseOption, curvesOrPoints)

Parameters:
  • inferCoincidentConstraints (NXOpen.SketchInferConstraintsOption) – Whether to automatically create coincident constraints when adding the geometry. If this flag is true and there exists another curve or point in the sketch that has a vertex that is at the same location (within system tolerance) as one of the vertices for crv, a coincident constraint will be created
  • ellipseOption (NXOpen.SketchAddEllipseOption) – If you are adding an ellipse to the sketch, this parameter indicates whether the ellipse should be treated as an ellipse or general conic. If you are not adding an ellipse, the option is ignored. See the documentation for NXOpen.SketchAddEllipseOption for more details. The default value is NXOpen.SketchAddEllipseOption.TreatAsEllipse. In order to treat an ellipse as a conic, its end angle minus its start angle must be less than 180 degrees.
  • curvesOrPoints (list of NXOpen.SmartObject) – Must be a curve or point

New in version NX6.0.1.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

AutoConstrain

Sketch.AutoConstrain

Creates Automatic Constraints on input set of geometries.

Signature AutoConstrain(linearTolerance, angularTolerance, allowRemoteConstraints, geometries, autoconstraintTypes)

Parameters:
  • linearTolerance (float) – Capture Distance
  • angularTolerance (float) – Capture Angle
  • allowRemoteConstraints (bool) – Allow remote constraints
  • geometries (list of NXOpen.SmartObject) – Array of geometries
  • autoconstraintTypes (list of NXOpen.SketchConstraintType) – Constraint type array
Returns:

Array of deduced constraints

Return type:

list of NXOpen.SketchConstraint

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

BreakAssociativity

Sketch.BreakAssociativity

Breaks associativity of recipe geometry (projected or intersection curves and points) in the sketch, making the curves regular sketch geometry.

Any non-recipe geometry is ignored. Call this before sketch update.

Signature BreakAssociativity(sketchGeoms)

Parameters:sketchGeoms (list of NXOpen.NXObject) – Recipe geometry in the active sketch

New in version NX11.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

ConvertToNx10Spline

Sketch.ConvertToNx10Spline

Convert the legacy splines to new NX10 splines.

The input spline will be upgraded to NX10 spline. No new splines will be created to replace the input spline.

Signature ConvertToNx10Spline(spline)

Parameters:spline (NXOpen.Spline) –

New in version NX10.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CopyObjects

Sketch.CopyObjects

Creates copies of input objects and constraints between these objects.

Signature CopyObjects(inputObjects)

Parameters:inputObjects (list of NXOpen.NXObject) – Objects to be copied
Returns:Copies of objects
Return type:list of NXOpen.NXObject

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CopyObjectsWithDimensionOutput

Sketch.CopyObjectsWithDimensionOutput

Creates copies of input objects and constraints between these objects.

This function is same as NXOpen.Sketch.CopyObjects() except that it returns an array of newly created dimensions

Signature CopyObjectsWithDimensionOutput(inputObjects)

Parameters:inputObjects (list of NXOpen.NXObject) – Objects to be copied
Returns:a tuple
Return type:A tuple consisting of (outputObjects, outputDims). outputObjects is a list of NXOpen.NXObject. Copies of objects outputDims is a list of NXOpen.NXObject. Copies of dims

New in version NX6.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CopyObjectsWithTracking

Sketch.CopyObjectsWithTracking

Creates copies of input objects and constraints between these objects.

Sketch dimensions are copied only if explicitly included in the input_objects array.

Signature CopyObjectsWithTracking(inputObjects)

Parameters:inputObjects (list of NXOpen.DisplayableObject) – Objects to be copied
Returns:Map between the original input object and the corresponding copied object
Return type:list of NXOpen.SketchCopyObjectData_Struct

New in version NX7.5.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateCoincidentConstraint

Sketch.CreateCoincidentConstraint

Creates a coincident constraint

Signature CreateCoincidentConstraint(geom1, geom2)

Parameters:
Returns:

The coincident constraint

Return type:

NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateCollinearConstraint

Sketch.CreateCollinearConstraint

Creates a collinear constraint.

One of the input constraint geometries must be a line.

Signature CreateCollinearConstraint(conGeom1, conGeom2)

Parameters:
Returns:

The collinear constraint

Return type:

NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateConcentricConstraint

Sketch.CreateConcentricConstraint

Creates a concentric constraint.

One of the input constraint geometries must be a curve.

Signature CreateConcentricConstraint(conGeom1, conGeom2)

Parameters:
Returns:

The concentric constraint

Return type:

NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateConstantAngleConstraint

Sketch.CreateConstantAngleConstraint

Creates a constant angle constraint

Signature CreateConstantAngleConstraint(conGeom)

Parameters:conGeom (NXOpen.SketchConstraintGeometry_Struct) – Must be a line
Returns:The constant angle constraint
Return type:NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateConstantLengthConstraint

Sketch.CreateConstantLengthConstraint

Creates a constant length constraint

Signature CreateConstantLengthConstraint(conGeom)

Parameters:conGeom (NXOpen.SketchConstraintGeometry_Struct) – Must be a line
Returns:The constant length constraint
Return type:NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateDiameterDimension

Sketch.CreateDiameterDimension

Overloaded method CreateDiameterDimension

  • CreateDiameterDimension(dimObject1, dimOrigin, expression)
  • CreateDiameterDimension(dimObject1, dimOrigin, expression, refDim)

-------------------------------------

Creates a diameter dimension constraint

Signature CreateDiameterDimension(dimObject1, dimOrigin, expression)

Parameters:
Returns:

The diametral dimension constraint

Return type:

NXOpen.SketchDimensionalConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Creates a diameter dimension constraint. Accepts a flag to create the dim as driving or reference

Signature CreateDiameterDimension(dimObject1, dimOrigin, expression, refDim)

Parameters:
Returns:

The diametral dimension constraint

Return type:

NXOpen.SketchDimensionalConstraint

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

CreateDimension

Sketch.CreateDimension

Overloaded method CreateDimension

  • CreateDimension(dimType, dimObject1, dimObject2, dimOrigin, expression)
  • CreateDimension(dimType, dimObject1, dimObject2, dimOrigin, expression, refDim)

-------------------------------------

Creates a dimension between two geometric objects. Do not use for radial, diameter, or perimeter dimensions. To create a radial or diameter constraint, use NXOpen.Sketch.CreateRadialDimension() or NXOpen.Sketch.CreateDiameterDimension(). To create a perimeter dimension, use NXOpen.Sketch.CreatePerimeterDimension()

Signature CreateDimension(dimType, dimObject1, dimObject2, dimOrigin, expression)

Parameters:
Returns:

The dimensional constraint

Return type:

NXOpen.SketchDimensionalConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Creates a dimension between two geometric objects. Do not use for radial, diameter, or perimeter dimensions. To create a radial or diameter constraint, use NXOpen.Sketch.CreateRadialDimension() or NXOpen.Sketch.CreateDiameterDimension(). To create a perimeter dimension, use NXOpen.Sketch.CreatePerimeterDimension(). This function takes in an argument to create the dimension as driving or reference.

Signature CreateDimension(dimType, dimObject1, dimObject2, dimOrigin, expression, refDim)

Parameters:
Returns:

The dimensional constraint

Return type:

NXOpen.SketchDimensionalConstraint

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

CreateEqualLengthConstraint

Sketch.CreateEqualLengthConstraint

Creates an equal length constraint.

One of the input constraint geometries must be a line.

Signature CreateEqualLengthConstraint(conGeom1, conGeom2)

Parameters:
Returns:

The equal length constraint

Return type:

NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateEqualRadiusConstraint

Sketch.CreateEqualRadiusConstraint

Creates an equal radius constraint.

One of the input constraint geometries must be a curve.

Signature CreateEqualRadiusConstraint(conGeom1, conGeom2)

Parameters:
Returns:

The equal radius constraint

Return type:

NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateFixedConstraint

Sketch.CreateFixedConstraint

Creates a fixed constraint

Signature CreateFixedConstraint(geom)

Parameters:geom (NXOpen.SketchConstraintGeometry_Struct) – Can be any curve, point, or vertex in the sketch
Returns:The fixed constraint
Return type:NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateFullyFixedConstraints

Sketch.CreateFullyFixedConstraints

Creates enough fixed constraints on the curve and all of its vertices such that the geometry is fully fixed without any redundant fixed constraints.

Signature CreateFullyFixedConstraints(geom)

Parameters:geom (NXOpen.SketchConstraintGeometry_Struct) – Can be any curve, point, or vertex in the sketch
Returns:The fixed constraints
Return type:list of NXOpen.SketchGeometricConstraint

New in version NX5.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateHorizontalConstraint

Sketch.CreateHorizontalConstraint

Creates a horizontal constraint

Signature CreateHorizontalConstraint(geom)

Parameters:geom (NXOpen.SketchConstraintGeometry_Struct) – Must be a line
Returns:The horizontal constraint
Return type:NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateMidpointConstraint

Sketch.CreateMidpointConstraint

Creates a midpoint constraint.

One of the input constraint geometries must be a vertex and the other must be a curve or edge.

Signature CreateMidpointConstraint(conGeom1, conGeom2)

Parameters:
Returns:

The midpoint constraint

Return type:

NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateNonUniformScaledConstraint

Sketch.CreateNonUniformScaledConstraint

Creates a non-uniform scale constraint

Signature CreateNonUniformScaledConstraint(conGeom)

Parameters:conGeom (NXOpen.SketchConstraintGeometry_Struct) – Must be a spline
Returns:The non-uniform scale constraint
Return type:NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateNormalConstraint

Sketch.CreateNormalConstraint

Creates a normal constraint.

A normal constraint can be created between any two curve/edge type except between two linear objects. For linear objects, create a perpendicular constraint

Signature CreateNormalConstraint(conGeom1, geom1Help, conGeom2, geom2Help)

Parameters:
Returns:

The normal constraint

Return type:

NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateParallelConstraint

Sketch.CreateParallelConstraint

Creates a parallel constraint.

A parallel constraint can only be created between one of the following pairs: (line, line or linear edge), (line, datum axis or datum plane), (line or linear edge, ellipse), (line, ellipse or elliptical edge), (ellipse, ellipse or elliptical edge).

Signature CreateParallelConstraint(conGeom1, conGeom2)

Parameters:
Returns:

The parallel constraint

Return type:

NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreatePerimeterDimension

Sketch.CreatePerimeterDimension

Creates a perimeter dimension constraint

Signature CreatePerimeterDimension(curves, dimOrigin, expression)

Parameters:
Returns:

The perimeter dimensional constraint

Return type:

NXOpen.SketchDimensionalConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreatePerpendicularConstraint

Sketch.CreatePerpendicularConstraint

Creates a perpendicular constraint.

A perpendicular constraint can only be created between one of the following pairs: (line, line or linear edge), (line, datum axis or datum plane), (line or linear edge, ellipse), (line, ellipse or elliptical edge), (ellipse, ellipse or elliptical edge).

Signature CreatePerpendicularConstraint(conGeom1, conGeom2)

Parameters:
Returns:

The perpendicular constraint

Return type:

NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreatePointOnCurveConstraint

Sketch.CreatePointOnCurveConstraint

Creates a point on curve constraint.

One of the input geometries must be a vertex and the other must be a curve, edge, datum axis, or datum plane.

Signature CreatePointOnCurveConstraint(conGeom1, conGeom2, help)

Parameters:
Returns:

The point on curve constraint

Return type:

NXOpen.SketchHelpedGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreatePointOnStringConstraint

Sketch.CreatePointOnStringConstraint

Overloaded method CreatePointOnStringConstraint

  • CreatePointOnStringConstraint(conGeom1, curvesInString, helpData, curveWhichHelpParamAppliesTo)
  • CreatePointOnStringConstraint(conGeom1, curveInString, helpData)

-------------------------------------

Creates a point on string constraint.

Signature CreatePointOnStringConstraint(conGeom1, curvesInString, helpData, curveWhichHelpParamAppliesTo)

Parameters:
  • conGeom1 (NXOpen.SketchConstraintGeometry_Struct) – Must be a vertex
  • curvesInString (list of NXOpen.Curve) – Must all be part of the same string. (You can create a string of curves through the UI through the Edit -<ja_gt> Project command.)
  • helpData (NXOpen.SketchConstraintGeometryHelp_Struct) –
  • curveWhichHelpParamAppliesTo (int) – If helpData is a parameter, this parameter indicates which curve in the curvesInString that the help parameter applies to. Otherwise, this parameter is not used
Returns:

The point on string constraint

Return type:

NXOpen.SketchHelpedGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Creates a point on string constraint. The string is specified using a single curve in the string. The constraint is created on the entire string that curveInString belongs to.

Signature CreatePointOnStringConstraint(conGeom1, curveInString, helpData)

Parameters:
Returns:

The point on string constraint

Return type:

NXOpen.SketchHelpedGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

CreateRadialDimension

Sketch.CreateRadialDimension

Overloaded method CreateRadialDimension

  • CreateRadialDimension(dimObject1, dimOrigin, expression)
  • CreateRadialDimension(dimObject1, dimOrigin, expression, refDim)

-------------------------------------

Creates a radial dimension constraint

Signature CreateRadialDimension(dimObject1, dimOrigin, expression)

Parameters:
Returns:

The radial dimension constraint

Return type:

NXOpen.SketchDimensionalConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Creates a radial dimension constraint. Accepts a flag to create the dimension as driving or reference

Signature CreateRadialDimension(dimObject1, dimOrigin, expression, refDim)

Parameters:
Returns:

The radial dimension constraint

Return type:

NXOpen.SketchDimensionalConstraint

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

CreateSlopeConstraint

Sketch.CreateSlopeConstraint

Creates a slope constraint.

One of the input constraint geometries must a spline defining point. The other must be datum axis, datum plane, or a curve or edge shaped as a line, arc, ellipse, conic, or spline.

Signature CreateSlopeConstraint(conGeom1, conGeom2)

Parameters:
Returns:

The slope constraint

Return type:

NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateTangentConstraint

Sketch.CreateTangentConstraint

Creates a tangent constraint.

Note: the input constraint geometries cannot both be linear.

Signature CreateTangentConstraint(geom1, geom1Help, geom2, geom2Help)

Parameters:
Returns:

The tangent constraint

Return type:

NXOpen.SketchTangentConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateUniformScaledConstraint

Sketch.CreateUniformScaledConstraint

Creates a uniform scale constraint

Signature CreateUniformScaledConstraint(conGeom)

Parameters:conGeom (NXOpen.SketchConstraintGeometry_Struct) – Must be a spline
Returns:The uniform scale constraint
Return type:NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

CreateVerticalConstraint

Sketch.CreateVerticalConstraint

Creates a vertical constraint

Signature CreateVerticalConstraint(geom)

Parameters:geom (NXOpen.SketchConstraintGeometry_Struct) – Must be a line
Returns:The vertical constraint
Return type:NXOpen.SketchGeometricConstraint

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

Deactivate

Sketch.Deactivate

Deactivates the sketch

Signature Deactivate(orientView, updateLevel)

Parameters:

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

DeleteConstraintsOnGeometries

Sketch.DeleteConstraintsOnGeometries

Overloaded method DeleteConstraintsOnGeometries

  • DeleteConstraintsOnGeometries(objects)
  • DeleteConstraintsOnGeometries(objects)
  • DeleteConstraintsOnGeometries(conClass, objects)

-------------------------------------

Deletes all geometric constraints associated with the object and all of its vertices. Converts all the driving dimensions associated with the object and its vertices to reference dimensions.

Signature DeleteConstraintsOnGeometries(objects)

Parameters:objects (list of NXOpen.NXObject) – Objects whose constraints needs to be deleted

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Deletes all geometric constraints associated with the object and all of its vertices. Converts all the driving dimensions associated with the object and its vertices to reference dimensions. The user can pass in a vertex to do the same on just the supplied vertex.

Signature DeleteConstraintsOnGeometries(objects)

Parameters:objects (list of NXOpen.SketchConstraintGeometry_Struct) – Objects whose constraints needs to be deleted

New in version NX8.5.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Deletes constraints associated with the input sketch geometry and vertices according to the constraint class, e.g.,

Signature DeleteConstraintsOnGeometries(conClass, objects)

Parameters:

New in version NX11.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

DeleteObjects

Sketch.DeleteObjects

Deletes objects from the sketch

Signature DeleteObjects(objects)

Parameters:objects (list of NXOpen.NXObject) – Objects to be deleted
Returns:List of errors encountered during the delete
Return type:NXOpen.ErrorList

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

EditSplineDefiningPoints

Sketch.EditSplineDefiningPoints

Changes the locations of the defining points of a spline.

The length of point array should be enough to cover existing defining points. You cannot add/remove points nor change knot sequence via this call.

Signature EditSplineDefiningPoints(spline, points)

Parameters:
  • spline (NXOpen.Spline) –
  • points (list of float) – point locations. Size is three times the number of points.

New in version NX10.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

EditSplinePoles

Sketch.EditSplinePoles

Changes the locations of the control poles of a spline.

The length of poles array should be enough to cover existing poles. You cannot add/remove poles nor change knot sequence via this call. The order of data in poles array is x, y, z, weight. You can edit any or all of these four values via this function.

Signature EditSplinePoles(spline, poles)

Parameters:
  • spline (NXOpen.Spline) –
  • poles (list of float) – pole locations. Size is four times the number of poles.

New in version NX10.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

Fillet

Sketch.Fillet

Overloaded method Fillet

  • Fillet(curve1, curve2, helpPoint1, helpPoint2, radius, doTrim, createRadiusDim, alternateSolution)
  • Fillet(curve1, curve2, helpPoint1, helpPoint2, pointOnArc, radius, doTrim, createRadiusDim, alternateSolution)
  • Fillet(curve1, curve2, curve3, helpPoint1, helpPoint2, helpPoint3, radius, doTrim, doDelete, createRadiusDim, alternateSolution)
  • Fillet(curve1, curve2, curve3, helpPoint1, helpPoint2, helpPoint3, pointOnArc, radius, doTrim, doDelete, createRadiusDim, alternateSolution)

-------------------------------------

Fillets curves and creates appropriate constraints. If the input curves have mirror constraints, the fillet is also performed on the mirror curves.

Signature Fillet(curve1, curve2, helpPoint1, helpPoint2, radius, doTrim, createRadiusDim, alternateSolution)

Parameters:
  • curve1 (NXOpen.Curve) – First curve for the fillet
  • curve2 (NXOpen.Curve) – Second curve for the fillet
  • helpPoint1 (NXOpen.Point3d) – Should be a point on the first curve. Indicates where the fillet should be created
  • helpPoint2 (NXOpen.Point3d) – Should be a point on the second curve. Indicates where the fillet should be created
  • radius (float) – Radius of the fillet
  • doTrim (NXOpen.SketchTrimInputOption) – Indicates whether the input curves should get trimmed by the fillet
  • createRadiusDim (NXOpen.SketchCreateDimensionOption) – Indicates whether a radius dimension should be created
  • alternateSolution (NXOpen.SketchAlternateSolutionOption) – Indicates whether the alternate solution should be used instead of the regular solution. The alternate solution for an arc is the portion of the full circle that is left out of the regular solution.
Returns:

a tuple

Return type:

A tuple consisting of (fillets, constraints). fillets is a list of NXOpen.Arc. The fillet arcs that are created. If the input curves do not have any mirror constraints, the number of fillet arcs will always be one. If the input curves have mirror constraints, fillets will be created on the mirrored curves, and all the fillet arcs that were created are returned constraints is a list of NXOpen.SketchConstraint. The constraints that were created by the fillet. If the input curves get trimmed, coincident and tangent constraints are created. If the input curves do not get trimmed, point on curve and tangent constraints are created.

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Fillets curves and creates appropriate constraints. If the input curves have mirror constraints, the fillet is also performed on the mirror curves.

Signature Fillet(curve1, curve2, helpPoint1, helpPoint2, pointOnArc, radius, doTrim, createRadiusDim, alternateSolution)

Parameters:
  • curve1 (NXOpen.Curve) – First curve for the fillet
  • curve2 (NXOpen.Curve) – Second curve for the fillet
  • helpPoint1 (NXOpen.Point3d) – Should be a point on the first curve. Indicates where the fillet should be created
  • helpPoint2 (NXOpen.Point3d) – Should be a point on the second curve. Indicates where the fillet should be created
  • pointOnArc (NXOpen.Point3d) – Point on fillet arc
  • radius (float) – Radius of the fillet
  • doTrim (NXOpen.SketchTrimInputOption) – Indicates whether the input curves should get trimmed by the fillet
  • createRadiusDim (NXOpen.SketchCreateDimensionOption) – Indicates whether a radius dimension should be created
  • alternateSolution (NXOpen.SketchAlternateSolutionOption) – Indicates whether the alternate solution should be used instead of the regular solution. The alternate solution for an arc is the portion of the full circle that is left out of the regular solution.
Returns:

a tuple

Return type:

A tuple consisting of (fillets, constraints). fillets is a list of NXOpen.Arc. The fillet arcs that are created. If the input curves do not have any mirror constraints, the number of fillet arcs will always be one. If the input curves have mirror constraints, fillets will be created on the mirrored curves, and all the fillet arcs that were created are returned constraints is a list of NXOpen.SketchConstraint. The constraints that were created by the fillet. If the input curves get trimmed, coincident and tangent constraints are created. If the input curves do not get trimmed, point on curve and tangent constraints are created.

New in version NX7.5.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Fillets curves and creates appropriate constraints. If the input curves have mirror constraints, the fillet is also performed on the mirror curves.

Signature Fillet(curve1, curve2, curve3, helpPoint1, helpPoint2, helpPoint3, radius, doTrim, doDelete, createRadiusDim, alternateSolution)

Parameters:
  • curve1 (NXOpen.Curve) – First curve for the fillet
  • curve2 (NXOpen.Curve) – Second curve for the fillet
  • curve3 (NXOpen.Curve) – Third curve for the fillet
  • helpPoint1 (NXOpen.Point3d) – Should be a point on the first curve. Indicates where the fillet should be created
  • helpPoint2 (NXOpen.Point3d) – Should be a point on the second curve. Indicates where the fillet should be created
  • helpPoint3 (NXOpen.Point3d) – Should be a point on the third curve. Indicates where the fillet should be created
  • radius (float) – Radius of the fillet
  • doTrim (NXOpen.SketchTrimInputOption) – Indicates whether the input curves should get trimmed by the fillet
  • doDelete (NXOpen.SketchDeleteThirdCurveOption) – Indicates whether the third curve should be deleted
  • createRadiusDim (NXOpen.SketchCreateDimensionOption) – Indicates whether a radius dimension should be created
  • alternateSolution (NXOpen.SketchAlternateSolutionOption) – Indicates whether the alternate solution should be used instead of the regular solution. The alternate solution for an arc is the portion of the full circle that is left out of the regular solution.
Returns:

a tuple

Return type:

A tuple consisting of (fillets, constraints). fillets is a list of NXOpen.Arc. The fillet arcs that are created. If the input curves do not have any mirror constraints, the number of fillet arcs will always be one. If the input curves have mirror constraints, fillets will be created on the mirrored curves, and all the fillet arcs that were created are returned constraints is a list of NXOpen.SketchConstraint. The constraints that were created by the fillet. If the input curves get trimmed, coincident and tangent constraints are created. If the input curves do not get trimmed, point on curve and tangent constraints are created.

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Fillets curves and creates appropriate constraints. If the input curves have mirror constraints, the fillet is also performed on the mirror curves.

Signature Fillet(curve1, curve2, curve3, helpPoint1, helpPoint2, helpPoint3, pointOnArc, radius, doTrim, doDelete, createRadiusDim, alternateSolution)

Parameters:
  • curve1 (NXOpen.Curve) – First curve for the fillet
  • curve2 (NXOpen.Curve) – Second curve for the fillet
  • curve3 (NXOpen.Curve) – Third curve for the fillet
  • helpPoint1 (NXOpen.Point3d) – Should be a point on the first curve. Indicates where the fillet should be created
  • helpPoint2 (NXOpen.Point3d) – Should be a point on the second curve. Indicates where the fillet should be created
  • helpPoint3 (NXOpen.Point3d) – Should be a point on the third curve. Indicates where the fillet should be created
  • pointOnArc (NXOpen.Point3d) – Point on fillet arc
  • radius (float) – Radius of the fillet
  • doTrim (NXOpen.SketchTrimInputOption) – Indicates whether the input curves should get trimmed by the fillet
  • doDelete (NXOpen.SketchDeleteThirdCurveOption) – Indicates whether the third curve should be deleted
  • createRadiusDim (NXOpen.SketchCreateDimensionOption) – Indicates whether a radius dimension should be created
  • alternateSolution (NXOpen.SketchAlternateSolutionOption) – Indicates whether the alternate solution should be used instead of the regular solution. The alternate solution for an arc is the portion of the full circle that is left out of the regular solution.
Returns:

a tuple

Return type:

A tuple consisting of (fillets, constraints). fillets is a list of NXOpen.Arc. The fillet arcs that are created. If the input curves do not have any mirror constraints, the number of fillet arcs will always be one. If the input curves have mirror constraints, fillets will be created on the mirrored curves, and all the fillet arcs that were created are returned constraints is a list of NXOpen.SketchConstraint. The constraints that were created by the fillet. If the input curves get trimmed, coincident and tangent constraints are created. If the input curves do not get trimmed, point on curve and tangent constraints are created.

New in version NX7.5.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

FindObject

Sketch.FindObject

Finds the NXOpen.NXObject with the given identifier as recorded in a journal.

An object may not return the same value as its JournalIdentifier in different versions of the software. However newer versions of the software should find the same object when FindObject is passed older versions of its journal identifier. In general, this method should not be used in handwritten code and exists to support record and playback of journals.

An exception will be thrown if no object can be found with the given journal identifier.

Signature FindObject(journalIdentifier)

Parameters:journalIdentifier (str) – Journal identifier of the object
Returns:
Return type:NXOpen.INXObject

New in version NX3.0.0.

License requirements: None.

FlipNormal

Sketch.FlipNormal

Flips the outward normal vector of the sketch

Signature FlipNormal()

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

FlipReferenceDirection

Sketch.FlipReferenceDirection

Flips the reference direction of the sketch

Signature FlipReferenceDirection()

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

GetAllConstraintsOfType

Sketch.GetAllConstraintsOfType

Gets all constraints in the sketch of a particular type

Signature GetAllConstraintsOfType(conClass, conType)

Parameters:
Returns:

All the constraints in the sketch of the specified type

Return type:

list of NXOpen.SketchConstraint

New in version NX3.0.0.

License requirements: None.

GetAllExpressions

Sketch.GetAllExpressions

Returns all the expressions in the sketch

Signature GetAllExpressions()

Returns:All the expressions in the sketch
Return type:list of NXOpen.Expression

New in version NX3.0.0.

License requirements: None.

GetAllGeometry

Sketch.GetAllGeometry

Returns all the curves and points in the sketch

Signature GetAllGeometry()

Returns:All the curves and points in the sketch
Return type:list of NXOpen.NXObject

New in version NX3.0.0.

License requirements: None.

GetConstraintsForGeometry

Sketch.GetConstraintsForGeometry

Gets all the constraints associated with a particular geometric item

Signature GetConstraintsForGeometry(geometry, conClass)

Parameters:
Returns:

All the constraints associated with the geometry that is input

Return type:

list of NXOpen.SketchConstraint

New in version NX3.0.0.

License requirements: None.

GetReferenceDirection

Sketch.GetReferenceDirection

Gets the reference direction of the sketch

Signature GetReferenceDirection()

Returns:a tuple
Return type:A tuple consisting of (referenceDirection, referenceAxis, referenceAxisOrientation, referenceAxisSense). referenceDirection is a NXOpen.Vector3d. referenceAxis is a NXOpen.IReferenceAxis. An edge, datum axis, datum plane, or face that the sketch uses as a reference. May be None. referenceAxisOrientation is a NXOpen.AxisOrientation. Indicates whether the reference axis is horizontal or vertical referenceAxisSense is a NXOpen.Sense. If reference axis is an edge or datum axis, this parameter indicates whether the reference axis is in the same direction as the edge or datum axis or in the opposite direction. If reference axis is not an edge or datum axis, this parameter is not used.

New in version NX3.0.0.

License requirements: None.

GetStatus

Sketch.GetStatus

Gets the status of the sketch and the number of degrees of freedom that remain in the sketch.

The status of the sketch indicates whether the sketch is fully constrained or under, over, or inconsistently constrained.

Signature GetStatus()

Returns:a tuple
Return type:A tuple consisting of (status, dofNeeded). status is a NXOpen.SketchStatus. The sketch’s status, which indicates how well constrained the sketch is dofNeeded is a int. The number of degrees of freedom left in the sketch

New in version NX3.0.0.

License requirements: None.

HideDimensions

Sketch.HideDimensions

Overloaded method HideDimensions

  • HideDimensions(inputObjects)
  • HideDimensions()
  • HideDimensions(objects)

-------------------------------------

Blanks dimensions in the active sketch associated with the input sketch geometry.

Signature HideDimensions(inputObjects)

Parameters:inputObjects (list of NXOpen.DisplayableObject) – Geometry and groups in active sketch

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Blanks all the dimensions of input sketch

Signature HideDimensions()

New in version NX6.0.1.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Blanks dimensions in the active sketch associated with the input sketch geometry. This function can accept vertices

Signature HideDimensions(objects)

Parameters:objects (list of NXOpen.SketchConstraintGeometry_Struct) – Geometry and vertices in active sketch

New in version NX8.5.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

LocalUpdate

Sketch.LocalUpdate

Update the sketch and not the sketch children.

If a different sketch is active the SKETCH_NOT_INITIALIZED error will return. The function works even if the sketch is not active.

Signature LocalUpdate()

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

MakeDatumsExternal

Sketch.MakeDatumsExternal

Makes the internal sketch placement face and directional reference datums external.

Signature MakeDatumsExternal()

New in version NX5.0.0.

Deprecated since version NX11.0.0: Please use NXOpen.Sketch.MakeDatumsExternal2() instead.

License requirements: solid_modeling (“SOLIDS MODELING”) OR geometric_tol (“GDT”)

MakeDatumsExternal2

Sketch.MakeDatumsExternal2

Makes the internal sketch placement face and directional reference datums external.

It should be called only when the internal datum is not a datum CSYS or is not a PlaneAxisPoint type of datum CSYS.

Signature MakeDatumsExternal2()

New in version NX11.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR geometric_tol (“GDT”)

MakeDatumsInternal

Sketch.MakeDatumsInternal

Makes the sketch placement face and directional reference internal to the sketch if they are both datums referenced only by the sketch.

Signature MakeDatumsInternal()

New in version NX5.0.0.

Deprecated since version NX11.0.0: None.

License requirements: solid_modeling (“SOLIDS MODELING”) OR geometric_tol (“GDT”)

ManageConstraintsAfterEdit

Sketch.ManageConstraintsAfterEdit

Deletes or adjusts constraints of the input geometry that are incompatible after geometry edit.

Call this before sketch update

Signature ManageConstraintsAfterEdit(sketchGeoms, preserveComplexConstraints)

Parameters:
  • sketchGeoms (list of NXOpen.NXObject) –
  • preserveComplexConstraints (bool) – Complex constraints are Pattern, Mirror and Offset

New in version NX11.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

MirrorObjects

Sketch.MirrorObjects

Creates a reflection of the input geometry.

This API is now deprecated. Please use NXOpen.SketchMirrorBuilder instead.

Signature MirrorObjects(centerline, objectsToMirror)

Parameters:
  • centerline (NXOpen.DisplayableObject) – Axis of reflection for the mirror. Must be a linear curve, edge, datum axis or datum plane
  • objectsToMirror (list of NXOpen.SmartObject) – Points and curves to mirror. None of the curves may be used as a centerline for another mirror operation
Returns:

The mirrored geometry that was created

Return type:

list of NXOpen.SmartObject

New in version NX4.0.0.

Deprecated since version NX5.0.0: Please use NXOpen.SketchMirrorBuilder instead.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”)

Print

Sketch.Print

Prints a representation of this object to the system log file.

Signature Print()

New in version NX3.0.0.

License requirements: None.

Reattach

Sketch.Reattach

Reattaches a sketch.

For documentation for the parameters for this method, see the documentation for NXOpen.SketchCollection.CreateSketch()

Signature Reattach(attachmentPlane, referenceAxis, referenceDirection, referenceAxisOrientation, referenceAxisSense, normalOrientation, localCoordinateSystemOrigin)

Parameters:

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

RemoveRedundantVertices

Sketch.RemoveRedundantVertices

Remove redundant vertices of the given sketch geometry

Signature RemoveRedundantVertices(geoms)

Parameters:geoms (list of NXOpen.NXObject) – Array of geometries

New in version NX11.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

RunAutoDimension

Sketch.RunAutoDimension

Run auto dimensioning.

Signature RunAutoDimension()

New in version NX7.5.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

Scale

Sketch.Scale

Scale the sketch entities by the given scale factor.

The sketch cannot be scaled if there are recipe curves or external constraints/dimensions or constraints/dimensions that controls the size of one or more geometries in the sketch. The sketch can have at most one non-angular driving dimension and that dimension must have its expression value scaled by the scale factor.

Signature Scale(scaleFactor)

Parameters:scaleFactor (float) – the scaleFactor must be gerater than zero

New in version NX11.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

SetName

Sketch.SetName

Sets the custom name of the object.

NOTE: This method should not be used to edit a read-only object such as a Mirrored PMI object. If it is, the changes will be overridden when the part is updated.

Signature SetName(name)

Parameters:name (str) –

New in version NX3.0.0.

License requirements: None.

SetReferenceDirection

Sketch.SetReferenceDirection

Sets the reference direction of the sketch.

For documentation for the parameters for this method, see the documentation for NXOpen.SketchCollection.CreateSketch().

Signature SetReferenceDirection(referenceAxis, referenceDirection, referenceAxisOrientation, referenceAxisSense)

Parameters:

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

ShowDimensions

Sketch.ShowDimensions

Overloaded method ShowDimensions

  • ShowDimensions(inputObjects)
  • ShowDimensions()
  • ShowDimensions(objects)

-------------------------------------

Unblanks dimensions in the active sketch associated with the input sketch geometry

Signature ShowDimensions(inputObjects)

Parameters:inputObjects (list of NXOpen.DisplayableObject) – Geometry and groups in active sketch

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Unblanks all the dimensions of input sketch

Signature ShowDimensions()

New in version NX6.0.1.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Unblanks dimensions in the active sketch associated with the input sketch geometry. This function can accept vertices.

Signature ShowDimensions(objects)

Parameters:objects (list of NXOpen.SketchConstraintGeometry_Struct) – Geometry and vertices in active sketch

New in version NX8.5.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Update

Sketch.Update

Overloaded method Update

  • Update()
  • Update(geoms)

-------------------------------------

Updates the sketch

Signature Update()

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Updates the given set of geometries in the sketch

Signature Update(geoms)

Parameters:geoms (list of NXOpen.NXObject) – Geoms that need to be updated

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

UpdateConstraintDisplay

Sketch.UpdateConstraintDisplay

Overloaded method UpdateConstraintDisplay

  • UpdateConstraintDisplay()
  • UpdateConstraintDisplay(geoms)

-------------------------------------

Updates the constraint display without updating the sketch

Signature UpdateConstraintDisplay()

New in version NX3.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Updates the constraint display of given set of geoms without updating the sketch

Signature UpdateConstraintDisplay(geoms)

Parameters:geoms (list of NXOpen.SmartObject) – Geoms for which cons must be re-displayed

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

UpdateDimensionDisplay

Sketch.UpdateDimensionDisplay

Overloaded method UpdateDimensionDisplay

  • UpdateDimensionDisplay()
  • UpdateDimensionDisplay(geoms)
  • UpdateDimensionDisplay(dims)

-------------------------------------

Updates the dimension display without updating the sketch

Signature UpdateDimensionDisplay()

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Updates the dimension display of given set of geoms without updating the sketch

Signature UpdateDimensionDisplay(geoms)

Parameters:geoms (list of NXOpen.SmartObject) – Geoms for which cons must be re-displayed

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Updates the dimension display of given set of dims without updating the sketch

Signature UpdateDimensionDisplay(dims)

Parameters:dims (list of NXOpen.NXObject) – Dims for which cons must be re-displayed

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”)

-------------------------------------

UpdateGeometryDisplay

Sketch.UpdateGeometryDisplay

Overloaded method UpdateGeometryDisplay

  • UpdateGeometryDisplay()
  • UpdateGeometryDisplay(geoms)

-------------------------------------

Updates the geometry display without updating the sketch

Signature UpdateGeometryDisplay()

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------

Updates the geometry display of given set of geoms without updating the sketch

Signature UpdateGeometryDisplay(geoms)

Parameters:geoms (list of NXOpen.SmartObject) – Geoms for which cons must be re-displayed

New in version NX4.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”) OR drafting (“DRAFTING”) OR geometric_tol (“GDT”)

-------------------------------------